CUTLASS: cutlass::Array< T, N, true > Class Template Reference

| CUTLASS CUDA Templates for Linear Algebra Subroutines and Solvers

- Main Page
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Classes | Public Types | Public Member Functions | Static Public Attributes | List of all members
cutlass::Array< T, N, true > Class Template Reference

Statically sized array for any data type.

`#include <array.h>`

## Classes
class | const_iterator
| Bidirectional constant iterator over elements. More...
class | const_reverse_iterator
| Bidirectional constant iterator over elements. More...
class | iterator
| Bidirectional iterator over elements. More...
class | reverse_iterator
| Bidirectional iterator over elements. More...

## Public Types
using | Storage = T
| Storage type. More...
using | Element = T
| Element type. More...
typedef T | value_type
typedef size_t | size_type
typedef ptrdiff_t | difference_type
typedef value_type & | reference
typedef value_type const & | const_reference
typedef value_type * | pointer
typedef value_type const * | const_pointer

## Public Member Functions
CUTLASS_HOST_DEVICE | Array ()
CUTLASS_HOST_DEVICE | Array (Array const &x)
CUTLASS_HOST_DEVICE void | clear ()
| Efficient clear method. More...
CUTLASS_HOST_DEVICE reference | at (size_type pos)
CUTLASS_HOST_DEVICE const_reference | at (size_type pos) const
CUTLASS_HOST_DEVICE reference | operator[] (size_type pos)
CUTLASS_HOST_DEVICE const_reference | operator[] (size_type pos) const
CUTLASS_HOST_DEVICE reference | front ()
CUTLASS_HOST_DEVICE const_reference | front () const
CUTLASS_HOST_DEVICE reference | back ()
CUTLASS_HOST_DEVICE const_reference | back () const
CUTLASS_HOST_DEVICE pointer | data ()
CUTLASS_HOST_DEVICE const_pointer | data () const
CUTLASS_HOST_DEVICE pointer | raw_data ()
CUTLASS_HOST_DEVICE const_pointer | raw_data () const
CUTLASS_HOST_DEVICE constexpr bool | empty () const
CUTLASS_HOST_DEVICE constexpr size_type | size () const
CUTLASS_HOST_DEVICE constexpr size_type | max_size () const
CUTLASS_HOST_DEVICE void | fill (T const &value)
CUTLASS_HOST_DEVICE iterator | begin ()
CUTLASS_HOST_DEVICE const_iterator | cbegin () const
CUTLASS_HOST_DEVICE iterator | end ()
CUTLASS_HOST_DEVICE const_iterator | cend () const
CUTLASS_HOST_DEVICE reverse_iterator | rbegin ()
CUTLASS_HOST_DEVICE const_reverse_iterator | crbegin () const
CUTLASS_HOST_DEVICE reverse_iterator | rend ()
CUTLASS_HOST_DEVICE const_reverse_iterator | crend () const

## Static Public Attributes
static size_t const | kStorageElements = N
| Number of storage elements. More...
static size_t const | kElements = N
| Number of logical elements. More...

## Member Typedef Documentation

template<typename T , int N>

typedef value_type const* cutlass::Array< T, N, true >::const_pointer

template<typename T , int N>

typedef value_type const& cutlass::Array< T, N, true >::const_reference

template<typename T , int N>

typedef ptrdiff_t cutlass::Array< T, N, true >::difference_type

template<typename T , int N>

using cutlass::Array< T, N, true >::Element = T

template<typename T , int N>

typedef value_type* cutlass::Array< T, N, true >::pointer

template<typename T , int N>

typedef value_type& cutlass::Array< T, N, true >::reference

template<typename T , int N>

typedef size_t cutlass::Array< T, N, true >::size_type

template<typename T , int N>

using cutlass::Array< T, N, true >::Storage = T

template<typename T , int N>

typedef T cutlass::Array< T, N, true >::value_type

## Constructor & Destructor Documentation

template<typename T , int N>

CUTLASS_HOST_DEVICE cutlass::Array< T, N, true >::Array | ( |  | ) |
| inline

template<typename T , int N>

CUTLASS_HOST_DEVICE cutlass::Array< T, N, true >::Array | ( | Array< T, N, true > const & | x | ) |
| inline

## Member Function Documentation

template<typename T , int N>

CUTLASS_HOST_DEVICE reference cutlass::Array< T, N, true >::at | ( | size_type | pos | ) |
| inline

template<typename T , int N>

CUTLASS_HOST_DEVICE const_reference cutlass::Array< T, N, true >::at | ( | size_type | pos | ) | const
| inline

template<typename T , int N>

CUTLASS_HOST_DEVICE reference cutlass::Array< T, N, true >::back | ( |  | ) |
| inline

template<typename T , int N>

CUTLASS_HOST_DEVICE const_reference cutlass::Array< T, N, true >::back | ( |  | ) | const
| inline

template<typename T , int N>

CUTLASS_HOST_DEVICE iterator cutlass::Array< T, N, true >::begin | ( |  | ) |
| inline

template<typename T , int N>

CUTLASS_HOST_DEVICE const_iterator cutlass::Array< T, N, true >::cbegin | ( |  | ) | const
| inline

template<typename T , int N>

CUTLASS_HOST_DEVICE const_iterator cutlass::Array< T, N, true >::cend | ( |  | ) | const
| inline

template<typename T , int N>

CUTLASS_HOST_DEVICE void cutlass::Array< T, N, true >::clear | ( |  | ) |
| inline

template<typename T , int N>

CUTLASS_HOST_DEVICE const_reverse_iterator cutlass::Array< T, N, true >::crbegin | ( |  | ) | const
| inline

template<typename T , int N>

CUTLASS_HOST_DEVICE const_reverse_iterator cutlass::Array< T, N, true >::crend | ( |  | ) | const
| inline

template<typename T , int N>

CUTLASS_HOST_DEVICE pointer cutlass::Array< T, N, true >::data | ( |  | ) |
| inline

template<typename T , int N>

CUTLASS_HOST_DEVICE const_pointer cutlass::Array< T, N, true >::data | ( |  | ) | const
| inline

template<typename T , int N>

CUTLASS_HOST_DEVICE constexpr bool cutlass::Array< T, N, true >::empty | ( |  | ) | const
| inline

template<typename T , int N>

CUTLASS_HOST_DEVICE iterator cutlass::Array< T, N, true >::end | ( |  | ) |
| inline

template<typename T , int N>

CUTLASS_HOST_DEVICE void cutlass::Array< T, N, true >::fill | ( | T const & | value | ) |
| inline

template<typename T , int N>

CUTLASS_HOST_DEVICE reference cutlass::Array< T, N, true >::front | ( |  | ) |
| inline

template<typename T , int N>

CUTLASS_HOST_DEVICE const_reference cutlass::Array< T, N, true >::front | ( |  | ) | const
| inline

template<typename T , int N>

CUTLASS_HOST_DEVICE constexpr size_type cutlass::Array< T, N, true >::max_size | ( |  | ) | const
| inline

template<typename T , int N>

CUTLASS_HOST_DEVICE reference cutlass::Array< T, N, true >::operator[] | ( | size_type | pos | ) |
| inline

template<typename T , int N>

CUTLASS_HOST_DEVICE const_reference cutlass::Array< T, N, true >::operator[] | ( | size_type | pos | ) | const
| inline

template<typename T , int N>

CUTLASS_HOST_DEVICE pointer cutlass::Array< T, N, true >::raw_data | ( |  | ) |
| inline

template<typename T , int N>

CUTLASS_HOST_DEVICE const_pointer cutlass::Array< T, N, true >::raw_data | ( |  | ) | const
| inline

template<typename T , int N>

CUTLASS_HOST_DEVICE reverse_iterator cutlass::Array< T, N, true >::rbegin | ( |  | ) |
| inline

template<typename T , int N>

CUTLASS_HOST_DEVICE reverse_iterator cutlass::Array< T, N, true >::rend | ( |  | ) |
| inline

template<typename T , int N>

CUTLASS_HOST_DEVICE constexpr size_type cutlass::Array< T, N, true >::size | ( |  | ) | const
| inline

## Member Data Documentation

template<typename T , int N>

size_t const cutlass::Array< T, N, true >::kElements = N
| static

template<typename T , int N>

size_t const cutlass::Array< T, N, true >::kStorageElements = N
| static

The documentation for this class was generated from the following file:

- array.h